unit Demo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Comobj;

type
    TCallBackFunction = Function(id : PGUID; param : Integer) : Integer;
    TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox1: TGroupBox;
    DevelopID: TEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label7: TLabel;
    ReadPassword: TEdit;
    WritePassword: TEdit;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    inputText: TEdit;
    Label6: TLabel;
    GroupBox4: TGroupBox;
    ComboBox1: TComboBox;
    GroupBox5: TGroupBox;
    Label3: TLabel;
    Label5: TLabel;
    plain: TEdit;
    key: TEdit;
    hash_test: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure encrypt_testClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure hash_testClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Function SKAPIInitialize(): integer; StdCall; External 'LTPKAPI.DLL';
Procedure SKAPIClose(); External 'LTPKAPI.DLL';
Function SKAPIGetUserData(id : PGUID; readPwd : Integer; buffer : PCHAR): integer; StdCall;
External 'LTPKAPI.DLL';
Function SKAPISetUserData(id : PGUID; writePwd : Integer; buffer : PCHAR): integer; StdCall;
External 'LTPKAPI.DLL';
Function SKAPIInitEncryptKey(nAlgorithm : Integer; id : PGUID; buffer : PCHAR): integer; StdCall;
External 'LTPKAPI.DLL';
Function SKAPIEncrypt(buffer : PCHAR): integer; StdCall;External 'LTPKAPI.DLL';
Function SKAPIDecrypt(buffer : PCHAR): integer; StdCall;External 'LTPKAPI.DLL';
Function SKAPIEnumDevices(EnumDeviceProc : TCallBackFunction; param : Integer): integer; StdCall;External 'LTPKAPI.DLL';

Function PKAPISHA1HashbyHard(pidDevelop:PGUID;lpUserReadPassword:integer;pucData:PCHAR;ulLength:integer;pucDigest:PCHAR):integer; StdCall;
External 'LTPKAPI.DLL';
Function PKAPISHA1HashbySoft(pidDevelop:PGUID;lpUserReadPassword:integer;pucData:PCHAR;ulLength:integer;pucKey:PCHAR;ulKeyLength:integer;pucDigest:PCHAR):integer; StdCall;
External 'LTPKAPI.DLL';


Function EnumDeviceProc(id : PGUID; param : Integer) : Integer;stdcall;
var
    strGuid : String;
begin
    strGuid := GUIDToString(id^);
    Form1.ComboBox1.Items.Add(strGuid);
    EnumDeviceProc := 1;
end;

procedure SKReadWrite(id : TGUID; readPwd, writePwd : Integer);
var
    ret : Integer;
    buffer : PCHAR;
begin
    GetMem(buffer, 64);
    ret := SKAPIInitialize();
    If (ret <> 0) Then
    begin
        ret := SKAPIGetUserData(@id, readPwd, buffer);
        if (ret <>0) then
        begin
            ret := SKAPISetUserData(@id, writePwd, buffer);
            SKAPIClose();
            FreeMem(buffer, 64);
            if (ret <> 0) then
                MessageBox(0,PCHAR('ǏeXgs'),PCHAR('Delphi Demo'), MB_OK)
            else
                MessageBox(0,PCHAR('ǏeXgs'),PCHAR('Delphi Demo'), MB_OK);
        end
        else
        begin
             SKAPIClose();
             FreeMem(buffer, 64);
             MessageBox(0,PCHAR('ǏeXg'),PCHAR('Delphi Demo'), MB_OK)
        end
     end
     else
        MessageBox(0,PCHAR('ǏeXgs'),PCHAR('Delphi Demo'), MB_OK)
end;

procedure TForm1.Button1Click(Sender: TObject);
var
        readPwd, writePwd : Integer;
        id : TGUID;
begin
        id := StringToGUID(DevelopID.Text);
        readPwd := StrToInt('$'+ReadPassword.Text);
        writePwd := StrtoInt('$' + WritePassword.Text);
        SKReadWrite(id, readPwd, writePwd);
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
        Close;
end;

procedure TForm1.encrypt_testClick(Sender: TObject);
var
    Len, i, a: integer;
    s: string;
    ret : Integer;
    buffer : PCHAR;
    id : TGUID;
    sCrypt : string;
begin
    id := StringToGUID(DevelopID.Text);
   ret := SKAPIInitialize();
   If (ret <> 0) Then
   begin
        ret := SKAPIInitEncryptKey(1, @id, NIL);
        if (ret <> 0) then
        begin
            Len := StrLen(PCHAR(inputText.Text+'        '));
            a := len div 8;
            s := inputText.Text+'        ';
            GetMem(buffer, 8+2);
            sCrypt := '';
            for i := 1 to a do
            begin
                buffer^ := chr(0);
                StrLCat(buffer, PCHAR(s)+(i-1)*8, 8);
                ret := SKAPIEncrypt(buffer);
                if ret<>0 then
                begin
                    sCrypt := sCrypt + buffer;
                    ret := SKAPIDecrypt(buffer);
                    if ret=0 then
                    begin
                        SKAPIClose();
                        MessageBox(0,PCHAR('ÍeXgs'),PCHAR('Delphi Demo'), MB_OK);
                        FreeMem(buffer);
                        Exit;
                    end
                end
                else
                begin
                    SKAPIClose();
                    MessageBox(0,PCHAR('ÍeXg'),PCHAR('Delphi Demo'), MB_OK);
                    FreeMem(buffer);
                    Exit;
                end;
           end;
           FreeMem(buffer);
           Label6.SetTextBuf(PCHAR(sCrypt));
        end;
            SKAPIClose();
            MessageBox(0,PCHAR('ÍeXgs'),PCHAR('Delphi Demo'), MB_OK)
     end
     else
        MessageBox(0,PCHAR('ÍeXgs'),PCHAR('Delphi Demo'), MB_OK)
end;

procedure TForm1.FormShow(Sender: TObject);
var
    ret : Integer;
begin
    ret := SKAPIInitialize();
    if (ret <> 0) then
    begin
        SKAPIEnumDevices(@EnumDeviceProc, 0);
        SKAPIClose();
        ComboBox1.ItemIndex := 0;
    end
end;

procedure TForm1.hash_testClick(Sender: TObject);
var
      s,s1:  string  ;

			i	 ,iDataLength, readPwd,	iKeyLength:integer ;
      id : TGUID     ;

      bRet,bResult:integer   ;
      digest,cDigest:PCHAR;//array [20] of char    ;

begin
  id := StringToGUID(DevelopID.Text);
  S  :=    plain.Text+'  ';
  s1 := key.Text+'  ';

  GetMem(digest, 20);
  GetMem(cDigest, 20);
  iDataLength :=plain.GetTextLen();
  iKeyLength := key.GetTextLen();

  readPwd := StrToInt('$'+ReadPassword.Text);

  bResult := 1;

  bRet := PKAPISHA1HashbySoft(@id,readPwd,PCHAR(s),iDataLength,PCHAR(s1),iKeyLength,digest)  ;

  if(bRet<>0) then
  begin
    bRet := 0    ;

    bRet :=PKAPISHA1HashbyHard(@id,readPwd,PCHAR(s),iDataLength,cDigest);

    if bRet<>0 then
    begin
          for i := 0 to  19 do
          begin
           if(cDigest[i]<>digest[i])then
           begin
                bResult :=0;
            end
          end
    end
    else
      bResult :=0;
  end
  else
    bResult :=0;

  if bResult<>1 then
     MessageBox(0,PCHAR('hash not same'),PCHAR('Delphi Demo'), MB_OK) ;
  if bResult=1 then
     MessageBox(0,PCHAR('hash success'),PCHAR('Delphi Demo'), MB_OK) ;

  FreeMem(digest);
  FreeMem(cDigest);
end;

end.

