// DemoVCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoVC.h"
#include "DemoVCDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SHA1_DIGEST_LENGTH     20


/////////////////////////////////////////////////////////////////////////////
// CDemoVCDlg dialog

CDemoVCDlg::CDemoVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoVCDlg)
	m_strReadPwd = _T("");
	m_strWritePwd = _T("");
	m_strDevelopID = _T("");
	m_strText = _T("");
	m_strCryptText = _T("");
	m_PlainText = _T("");
	m_SecurityKey = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoVCDlg)
	DDX_Control(pDX, IDC_COMBODEVICE, m_cboDeviceID);
	DDX_Text(pDX, IDC_EDITREADPWD, m_strReadPwd);
	DDV_MaxChars(pDX, m_strReadPwd, 8);
	DDX_Text(pDX, IDC_EDITWRITEPWD, m_strWritePwd);
	DDV_MaxChars(pDX, m_strWritePwd, 8);
	DDX_Text(pDX, IDC_DEVELOPID, m_strDevelopID);
	DDV_MaxChars(pDX, m_strDevelopID, 38);
	DDX_Text(pDX, IDC_EDITTEXT, m_strText);
	DDX_Text(pDX, IDC_CRYPTTEXT, m_strCryptText);
	DDX_Text(pDX, IDC_PLEXEDIT, m_PlainText);
	DDX_Text(pDX, IDC_KEYEDIT, m_SecurityKey);
	DDV_MaxChars(pDX, m_SecurityKey, 64);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoVCDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoVCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_READWRITE, OnWrite)
	ON_BN_CLICKED(IDC_ENCRYPTDECRYPT, OnEncryptdecrypt)
	ON_BN_CLICKED(IDC_HASH, OnHash)
	ON_CBN_EDITCHANGE(IDC_COMBODEVICE, OnEditchangeCombodevice)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoVCDlg message handlers

HRESULT FormatStringToGUID(char *szGUID,GUID *pguid)
{
	OLECHAR wszGUID[39];
	mbstowcs(wszGUID,szGUID,39);
	wszGUID[38] = 0;
	return CLSIDFromString(wszGUID,pguid);
}


HRESULT FormatGUIDToString(GUID guid, char *szGUID, int size)
{
	if (size < 39)
	{
		return FALSE;
	}
	sprintf(szGUID, "{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}", 
		guid.Data1, guid.Data2, guid.Data3, guid.Data4[0], guid.Data4[1], guid.Data4[2],
		guid.Data4[3], guid.Data4[4], guid.Data4[5], guid.Data4[6], guid.Data4[7]);

	return 0;
}

BOOL WINAPI EnumDeviceProc(GUID* pidDevice, DWORD dwParam)
{
	CDemoVCDlg* pSKDlg = (CDemoVCDlg*)dwParam;

	char szDevID[64];
	FormatGUIDToString(*pidDevice, szDevID, sizeof(szDevID));
	pSKDlg->m_cboDeviceID.AddString(szDevID);

	return TRUE;
}


BOOL CDemoVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	if(SKAPIInitialize())
	{
		SKAPIEnumDevices(EnumDeviceProc, (DWORD)this);
		m_cboDeviceID.SetCurSel(0);
		SKAPIClose();
	}
	// TODO: Add extra initialization here
	hhook = SetWindowsHookEx(WH_KEYBOARD, KeyboardProc, NULL, GetCurrentThreadId());

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoVCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoVCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoVCDlg::OnWrite() 
{
	// TODO: Add your control notification handler code here

	static BOOL bFirst = FALSE;
	UpdateData(TRUE);

	if(SKAPIInitialize())
	{
		DWORD i1;
		GUID guidDevice, guidDevelop;
		DWORD i2;
		DWORD dwWritePassword;
		DWORD dwReadPassword;
		BYTE byData[64];
		CString strDeviceID;

		DWORD dwIndex = m_cboDeviceID.GetCurSel();		
		m_cboDeviceID.GetLBText(dwIndex, strDeviceID);

		if(FormatStringToGUID(strDeviceID.GetBuffer(0), &guidDevice) != NOERROR)
		{
			AfxMessageBox("Device ID error");
		}

		if(FormatStringToGUID(m_strDevelopID.GetBuffer(0), &guidDevelop) != NOERROR)
		{
			AfxMessageBox("Develop ID error");
		}

		sscanf(m_strReadPwd, "%lx", &dwReadPassword);
		sscanf(m_strWritePwd, "%lx", &dwWritePassword);

		// Read LOCK STAR User Data;
		if(!PKAPIGetUserData(&guidDevice, &guidDevelop, dwReadPassword, byData))
//		if(!SKAPIGetUserData(&guidDevelop, dwReadPassword, byData))
		{
			AfxMessageBox(IDS_READFAILED);
			SKAPIClose();
			return;
		}

		// Write LOCK STAR User Data;
		memset(byData, 0, 64);
		if(!PKAPISetUserData(&guidDevice, &guidDevelop, dwWritePassword, byData)) 
//		if(!SKAPISetUserData(&guidDevelop, dwWritePassword, byData))
		{
			AfxMessageBox(IDS_WRITEFAILED);
			SKAPIClose();
			return;
		}

		// Read and Write Successfully;
		AfxMessageBox(IDS_WRITESUCCESS);
		SKAPIClose();
		return;

		UNREFERENCED_PARAMETER(i1);
		UNREFERENCED_PARAMETER(i2);
	}
	AfxMessageBox(IDS_INITSKAPIFAILED);
}


HHOOK CDemoVCDlg::hhook = NULL;
LRESULT CALLBACK CDemoVCDlg::KeyboardProc(int code, WPARAM wParam, LPARAM lParam)
{
	if (code >= 0)
	{
		if ((long)lParam > 0)
		{
			HWND hwnd = ::GetFocus();
			if (hwnd != NULL)
			{
				UINT nID = ::GetWindowID(hwnd);
				if (nID == IDC_EDITREADPWD || nID == IDC_EDITWRITEPWD)
				{
					if ((wParam >= 'A' && wParam <= 'F') || 
						(wParam >= '0' && wParam <= '9') ||
						(wParam >= VK_NUMPAD0 && wParam <= VK_NUMPAD9))
					{
						if (wParam >= '0' && wParam <= '9')
						{
							if (GetKeyState(VK_SHIFT) < 0)
							{
								return TRUE;
							}
						}

						if (::GetWindowTextLength(hwnd) == ::SendMessage(hwnd, EM_GETLIMITTEXT, 0, 0) - 1)
						{
							HWND hwndNext = ::GetNextDlgTabItem(::GetParent(hwnd), hwnd, FALSE);
							if (hwndNext != NULL && hwndNext != hwnd)
							{
								::SetFocus(hwndNext);
								Edit_SetSel(hwndNext, 0, -1);
							}
						}
					}
					else
					{
						if (wParam == VK_BACK || wParam == VK_DELETE ||
							wParam == VK_LEFT || wParam == VK_RIGHT ||
							wParam == VK_UP || wParam == VK_DOWN ||
							wParam == VK_PRIOR || wParam == VK_NEXT ||
							wParam == VK_HOME || wParam == VK_END ||
							wParam == VK_ESCAPE || wParam == VK_RETURN ||
							wParam == VK_SHIFT || wParam == VK_CONTROL ||
							wParam == VK_CAPITAL || wParam == VK_INSERT ||
							wParam == VK_TAB)
						{
						}
						else
						{
							return TRUE;
						}
					}
				}
				else if (nID == IDC_DEVELOPID)
				{
					if ((wParam >= 'A' && wParam <= 'F') || 
						(wParam >= '0' && wParam <= '9') ||
						(wParam >= VK_NUMPAD0 && wParam <= VK_NUMPAD9) ||
						wParam == 0xDB/*'{'*/ || wParam == 0xDD/*'}'*/ || wParam == 0xBD/*'-'*/)
					{
						if ((wParam >= '0' && wParam <= '9') || wParam == 0xBD)
						{
							if (GetKeyState(VK_SHIFT) < 0)
							{
								return TRUE;
							}
						}
						else if (wParam == 0xDB || wParam == 0xDD)
						{
							if (GetKeyState(VK_SHIFT) >= 0)
							{
								return TRUE;
							}
						}
					}
					else
					{
						if (wParam == VK_BACK || wParam == VK_DELETE ||
							wParam == VK_LEFT || wParam == VK_RIGHT ||
							wParam == VK_UP || wParam == VK_DOWN ||
							wParam == VK_PRIOR || wParam == VK_NEXT ||
							wParam == VK_HOME || wParam == VK_END ||
							wParam == VK_ESCAPE || wParam == VK_RETURN ||
							wParam == VK_SHIFT || wParam == VK_CONTROL ||
							wParam == VK_CAPITAL || wParam == VK_INSERT ||
							wParam == VK_TAB)
						{
						}
						else
						{
							return TRUE;
						}
					}
				}
			}
		}
	}

	return CallNextHookEx(hhook, code, wParam, lParam);
}

#pragma optimize( "", off )
void CDemoVCDlg::OnEncryptdecrypt() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);

	if(SKAPIInitialize())
	{
		DWORD f1;
		GUID guid;
		DWORD h2;
		
		sscanf(m_strDevelopID, "{%lx%-%hx%-%hx%-%02x%02x%-%02x%02x%02x%02x%02x%02x}", 
				&guid.Data1, &guid.Data2, &guid.Data3, 
				&guid.Data4[0], &guid.Data4[1], &guid.Data4[2], &guid.Data4[3],
				&guid.Data4[4], &guid.Data4[5], &guid.Data4[6], &guid.Data4[7]);

		UNREFERENCED_PARAMETER(f1);
		UNREFERENCED_PARAMETER(h2);

		// Init Encrypt Key
		if(!SKAPIInitEncryptKey(SKAPI_ALGORITHM_IDEA, &guid, NULL))
//		if(!SKAPIInitEncryptKey(SKAPI_ALGORITHM_HARDWARE, &guid, NULL))
		{
			AfxMessageBox(IDS_WRITEFAILED);
			SKAPIClose();
			return;
		}

		// Encrypt data;
		BYTE byData[8];
		int iLen, j=0;
		BYTE *pText;
		BYTE *pText1;
		BYTE *pCryptBuffer;

		iLen = m_strText.GetLength()+8;
		int a,i;
		a = iLen/8;
	
		pCryptBuffer = new BYTE[iLen+8];
		pText = new BYTE[iLen+8];
		pText1 = new BYTE[iLen+8];
		memset(pText, 0, iLen+8);
		memcpy(pText, m_strText, iLen);
		LPBYTE pBuffer = pCryptBuffer;
		for(i=0; i<a; i++)
		{
			memset(byData, 0, 8);
			memcpy((LPSTR)byData, pText, 8);
			if(!SKAPIEncrypt(byData))
			{
				AfxMessageBox(IDS_ENCRYPTFAILED);
				SKAPIClose();
				delete pCryptBuffer;
				delete pText;
				return;
			}
			memcpy(pBuffer, byData, 8);
			pBuffer+=8;
			pText +=8;
		}

//		AfxMessageBox((char *)pCryptBuffer);
		// Decrypt data;
		pBuffer = pCryptBuffer;
		for(i=0;i<a;i++)
		{
			memcpy(byData, pBuffer, 8);
			if(!SKAPIDecrypt(byData))
			{
				AfxMessageBox(IDS_ENCRYPTFAILED);
				SKAPIClose();
				delete pCryptBuffer;
				delete pText;
				return;
			}
//			memcpy(pBuffer, byData, 8);
			pBuffer+=8;
		}
		
		AfxMessageBox((char *)byData);
		m_strCryptText = pCryptBuffer;
		UpdateData(FALSE);

		delete pCryptBuffer;
		//delete pText;
		// Encrypt and Decrypt Successfully;
		AfxMessageBox(IDS_ENCRYPTSUCCESS);
		SKAPIClose();
		return;
	}
	AfxMessageBox(IDS_INITSKAPIFAILED);
}

#pragma optimize( "", on )



void CDemoVCDlg::OnHash() 
{
//HASH WITH KEY

	CString str;
	int j										= 0;
	int i										= 0;
	unsigned long iDataLength									= 0;
	unsigned long iKeyLength						= 0;
//	unsigned char *buffer						= NULL;
	unsigned char buffer[55];
	unsigned char *pKey							= NULL;
	DWORD iOffset								= 0;
	unsigned long iRetLen						= 0;
	unsigned char digest[SHA1_DIGEST_LENGTH]    = {0};
	unsigned char cDigest[SHA1_DIGEST_LENGTH]   = {0};
	
//	buffer				= (unsigned char *)malloc(55);
	memset(buffer, 0, 55);

	pKey				= (unsigned char *)malloc(64);
	memset(pKey, 0, 64);
   
	UpdateData(TRUE);
	if(SKAPIInitialize())
	{
		GUID guid;

	
		sscanf(m_strDevelopID, "{%lx%-%hx%-%hx%-%02x%02x%-%02x%02x%02x%02x%02x%02x}", 
				&guid.Data1, &guid.Data2, &guid.Data3, 
				&guid.Data4[0], &guid.Data4[1], &guid.Data4[2], &guid.Data4[3],
				&guid.Data4[4], &guid.Data4[5], &guid.Data4[6], &guid.Data4[7]);
		if(m_PlainText.IsEmpty())
		{
			AfxMessageBox("Plain cann't be empty");
//			free(buffer);
			free(pKey);
			SKAPIClose();
			return;
		}

		if(m_SecurityKey.IsEmpty())
		{
			AfxMessageBox("key cann't be empty");
//			free(buffer);
			free(pKey);
			SKAPIClose();
			return;
		}

		iDataLength			= m_PlainText.GetLength() > 55 ? 55 : m_PlainText.GetLength();
		memcpy(buffer, m_PlainText.GetBuffer(0), iDataLength);
	

		iKeyLength			= m_SecurityKey.GetLength() > 64 ? 64 : m_SecurityKey.GetLength();
		memcpy(pKey, m_SecurityKey.GetBuffer(0), iKeyLength);
	

	
		DWORD  dwReadPassword;

		sscanf(m_strReadPwd, "%lx", &dwReadPassword);

		if(PKAPISHA1HashbySoft(&guid,dwReadPassword ,buffer, iDataLength, pKey, iKeyLength, digest) == NULL)
		{
			AfxMessageBox("soft hash error");
//			free(buffer);
			free(pKey);
			SKAPIClose();
			return;
		}

		for(i = 0; i < SHA1_DIGEST_LENGTH; i++)
		{
			str.Format("%2x ", digest[i]);
			str.Empty();
		}

		if(PKAPISHA1HashbyHard(&guid, dwReadPassword, buffer, iDataLength, cDigest) == NULL)
	    {
			AfxMessageBox("hard error");
//			free(buffer);
			free(pKey);
			SKAPIClose();
			return;
		}

		str.Empty();

		for(j = 0; j < SHA1_DIGEST_LENGTH; j++)
		{
			str.Format("%2x ", cDigest[j]);
			str.Empty();
		}

		if(strncmp((char *)cDigest, (char *)digest, SHA1_DIGEST_LENGTH) == 0)
		{
			AfxMessageBox("hash success");
		}
		else
		{
			AfxMessageBox("key error");
		}

//		free(buffer);
		free(pKey);
		SKAPIClose();
		}
	}

void CDemoVCDlg::OnEditchangeCombodevice() 
{
	GUID guid;
	char str[64];

	m_cboDeviceID.GetWindowText(str, sizeof(str));
	sscanf(str, "{%lx%-%hx%-%hx%-%02x%02x%-%02x%02x%02x%02x%02x%02x}", 
		&guid.Data1, &guid.Data2, &guid.Data3, 
		&guid.Data4[0], &guid.Data4[1], &guid.Data4[2], &guid.Data4[3],
		&guid.Data4[4], &guid.Data4[5], &guid.Data4[6], &guid.Data4[7]);

	g_guid =guid;
}
